#include <stdlib.h>
#include <stdio.h>
#include <GL/glut.h>
#include <math.h>
#include "vector.h"
#include "obj.h"

#define  NMAX 20

/***********************************************
 * BezierȐ̍WvZ̊֐
 ************************************************/
struct Vec3D bezier(int n, double t, GLfloat *plist)
{
  float wx[NMAX],wy[NMAX],wz[NMAX];
  int m,i,j;
  struct Vec3D P;
  
  for( i=0 ; i<=n ; i++ ){
    wx[i] = plist[i*3+0];
    wy[i] = plist[i*3+1];
    wz[i] = plist[i*3+2];
  }
  for (m=1; m <= n; m++) {
    for (j=0; j <= n-m; j++) {
      wx[j] += (wx[j+1]-wx[j])*t;
      wy[j] += (wy[j+1]-wy[j])*t;
      wz[j] += (wz[j+1]-wz[j])*t;
    }
  }
  P.x = wx[0]; P.y= wy[0]; P.z= wz[0];
  return(P);
}
/***********************************************
 * main function for Bezier curve
 ************************************************/
int plot_Bezier(int pnum, GLfloat *plist, GLfloat *points, int step )
{
  int n;
  int nn,it;
  float t ;
  struct Vec3D P;
  struct Vec3D oldP;
  int i ;
  
  n = pnum/3-1 ;
  nn = step*n;            /* Ȑnn̐܂ߎ@*/
  oldP.x=plist[0] ;
  oldP.y=plist[1] ;
  oldP.z=plist[2] ;
  i=0 ;
  for( it=1; it <= nn; it++ ){
    t = (float)it/( float)nn;
    P = bezier(n,t,plist);
    points[i+0]=P.x;
    points[i+1]=P.y;
    points[i+2]=P.z;
    i+=3 ;
    oldP=P ;
  }
  return(0) ;
}
