#include <windows.h>
#include <stdlib.h>
#include <math.h>
#include "gluw.h"
#include "vector.h"
#include "obj.h"
#include "hair.h"

void gluw_display(void)
{
  int i,j ;
  
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glLoadIdentity();
  
  glViewport(0, 0, view3d.win_w, view3d.win_h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(view3d.fov, (double)view3d.win_w / (double)view3d.win_h, 0.3, 200.0);
  gluLookAt(view3d.v.x, view3d.v.y, view3d.v.z,
	    view3d.c.x, view3d.c.y, view3d.c.z,
	    view3d.u.x, view3d.u.y, view3d.u.z) ;
  glMatrixMode(GL_MODELVIEW);
    
  glLoadIdentity();
  glLightfv(GL_LIGHT0, GL_POSITION, light0pos);

  { /*** Draw cursor ***/
    glDisable(GL_LIGHTING);
    glPointSize(8.0);
    glColor3f(1.0, 0.0, 0.0);
    glBegin(GL_POINTS);
    glVertex3f(view3d.cur.x, view3d.cur.y, 0.0) ;
    glEnd();
  }

  glTranslated( view3d.p.x , view3d.p.y , view3d.p.z);
  glRotated( view3d.r.x , 1.0, 0.0, 0.0 );
  glRotated( view3d.r.y , 0.0, 1.0, 0.0 );

  if( HOBJ!=NULL ){
    /*** Draw hair-surface***/
    if( view3d.hs.n > 0 ){
      int k,l ;
      GLfloat mat_diffuse[] = { 0.5, 0.5, 0.9, 1.0 };
      GLfloat mat_ambient[] = { 0.2,0.2,0.2,1.0 } ;
      
      glEnable(GL_LIGHTING);
      glEnable(GL_LIGHT0);
      glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
      glLightfv(GL_LIGHT0, GL_AMBIENT, mat_ambient ) ;
      glEnable(GL_AUTO_NORMAL);
      glEnable(GL_NORMALIZE);
      
      for( i=0 ; i<view3d.hs.n ; i++ ){
	for( k=0 ; k<2 ; k++ ){
	  for( l=0 ; l<12 ; l++ ){
	    s_ctlpoints[ 0 + l] = HOBJ->hgl->HG[view3d.hs.hg1[i]].plist[l+k*9] ;
	    s_ctlpoints[12 + l] = HOBJ->hgl->HG[view3d.hs.hg2[i]].plist[l+k*9] ;
	    s_ctlpoints[24 + l] = HOBJ->hgl->HG[view3d.hs.hg1[i]].plist[l+k*9] ;
	    s_ctlpoints[36 + l] = HOBJ->hgl->HG[view3d.hs.hg2[i]].plist[l+k*9] ;
	  }
	  gluBeginSurface(theNurb);
	  gluNurbsSurface(theNurb, 
			  8, s_knots,
			  8, s_knots,
			  4 * 3,
			  3,
			  &s_ctlpoints[0], 
			  4, 4,
			  GL_MAP2_VERTEX_3);
	  gluEndSurface(theNurb);
	}
      }
    }
    
    /*** Draw hair ***/
    if(opstat.hideHG==0) {
      glDisable(GL_LIGHTING);
      for( i=0 ; i<HOBJ->hgl->n ; i++ ){
	if( view3d.gp[HOBJ->hgl->HG[i].gid].hide==0 ){
	  if( i==(view3d.HGno.n) ){
	    glColor3f(1.0, 0.0, 0.0);
	  }else{
	    if( HOBJ->hgl->HG[i].sel!=0 ){
	      glColor3f(0.5, 0.0, 0.0);
	    }else{
	      glColor3f(view3d.gp[HOBJ->hgl->HG[i].gid].lc[0],
			view3d.gp[HOBJ->hgl->HG[i].gid].lc[1],
			view3d.gp[HOBJ->hgl->HG[i].gid].lc[2]) ;
	    }
	  }
	  for( j=0 ; j<((HOBJ->hgl->HG[i].pnum/3)-1)/3 ; j++ ){
	    gluBeginCurve(theNurb);
	    gluNurbsCurve( theNurb,
			   HOBJ->hgl->HG[i].nknot, HOBJ->hgl->HG[i].knots,
			   3,
			   &HOBJ->hgl->HG[i].plist[(j*3)*3],
			   4,
			   GL_MAP1_VERTEX_3) ;
	    gluEndCurve(theNurb);
	  }
	}
      }
    }
    
    /*** Draw hair cntl point ***/
    if(opstat.hideHGP==0) {
      glDisable(GL_LIGHTING);
      for( i=0 ; i<HOBJ->hgl->n ; i++ ){
	if( view3d.gp[HOBJ->hgl->HG[i].gid].hide==0 ){
	  for( j=0 ; j<HOBJ->hgl->HG[i].pnum ; j+=3 ){
	    if( (j/3)%3==0 ){
	      glPointSize(5.0);
	    }else{
	      glPointSize(3.0);
	    }
	    glBegin(GL_POINTS);
	    if( j==0 ){
	      glColor3f(0.0, 0.0, 1.0);
	    }else{
	      if( i==(view3d.HGno.n) ){
		glColor3f(1.0, 0.0, 0.0);
	      }else{
		if( HOBJ->hgl->HG[i].sel!=0 ){
		  glColor3f(0.5, 0.0, 0.0);
		}else{
		  glColor3f(view3d.gp[HOBJ->hgl->HG[i].gid].pc[0],
			    view3d.gp[HOBJ->hgl->HG[i].gid].pc[1],
			    view3d.gp[HOBJ->hgl->HG[i].gid].pc[2]) ;
		}
	      }
	    }
	    glVertex3f(HOBJ->hgl->HG[i].plist[j+0],HOBJ->hgl->HG[i].plist[j+1],HOBJ->hgl->HG[i].plist[j+2]) ;
	    glEnd();
	  }
	}
	if( view3d.HGno.n>=0 ){
	  if( view3d.gp[HOBJ->hgl->HG[view3d.HGno.n].gid].hide==0 ){
	    int i=view3d.HGno.n ;
	    for( j=0 ; j<HOBJ->hgl->HG[i].pnum ; j+=3 ){
	      if( (j/3)%3==1 ){
		glBegin(GL_LINES);
		glColor3f(1.0, 0.0, 0.0);
		glVertex3fv(&HOBJ->hgl->HG[i].plist[j]);
		glVertex3fv(&HOBJ->hgl->HG[i].plist[j-3]);
		glEnd();
	      }else if( (j/3)%3==2 ){
		glBegin(GL_LINES);
		glColor3f(1.0, 0.0, 0.0);
		glVertex3fv(&HOBJ->hgl->HG[i].plist[j]);
		glVertex3fv(&HOBJ->hgl->HG[i].plist[j+3]);
		glEnd();
	      }
	    }
	  }
	}
      }
    }
    
    /*** Draw head object ***/
    if( opstat.hideHead==0 ){
      GLfloat mat_diffuse[] = { 0.7, 0.7, 0.7, 1.0 };
      GLfloat mat_ambient[] = { 0.2,0.2,0.2,1.0 } ;
      
      glEnable(GL_LIGHTING);
      glEnable(GL_LIGHT0);
      glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
      glLightfv(GL_LIGHT0, GL_AMBIENT, mat_ambient ) ;
      glBegin( GL_TRIANGLES ) ;
      for ( j=0 ; j < HOBJ->head->fnum ; j++ ){
	GLdouble vertex[3] ;
	
	glColor3f(1.0, 1.0, 1.0);
	vertex[0]=HOBJ->head->flist[j].normal.x ;
	vertex[1]=HOBJ->head->flist[j].normal.y ;
	vertex[2]=HOBJ->head->flist[j].normal.z ;
	glNormal3dv(vertex);
	vertex[0]=HOBJ->head->plist[HOBJ->head->flist[j].p2].x ;
	vertex[1]=HOBJ->head->plist[HOBJ->head->flist[j].p2].y ;
	vertex[2]=HOBJ->head->plist[HOBJ->head->flist[j].p2].z ;
	glVertex3dv(vertex);
	vertex[0]=HOBJ->head->plist[HOBJ->head->flist[j].p1].x ;
	vertex[1]=HOBJ->head->plist[HOBJ->head->flist[j].p1].y ;
	vertex[2]=HOBJ->head->plist[HOBJ->head->flist[j].p1].z ;
	glVertex3dv(vertex);
	vertex[0]=HOBJ->head->plist[HOBJ->head->flist[j].p0].x ;
	vertex[1]=HOBJ->head->plist[HOBJ->head->flist[j].p0].y ;
	vertex[2]=HOBJ->head->plist[HOBJ->head->flist[j].p0].z ;
	glVertex3dv(vertex);
      }
      glEnd();
    }
    
    /*** Draw hair root point ***/
    if( opstat.hideHeadP==0 ){
      glPointSize(5.0);
      glDisable(GL_LIGHTING);
      glBegin(GL_POINTS);
      for( i=0 ; i<HOBJ->head->pnum ; i++ ){
	if( HOBJ->head->draw[i]==0 ) continue ;
	if( i==(view3d.HRno) ){
	  glColor3f(1.0, 0.0, 0.0);
	}else{
	  if( HOBJ->head->sel[i]==1 ){
	    glColor3f(0.5, 0.0, 0.0);
	  }else{
	    glColor3f(1.0, 1.0, 1.0);
	  }
	}
	glVertex3f(HOBJ->head->plist[i].x,HOBJ->head->plist[i].y,HOBJ->head->plist[i].z) ;
      }
      glEnd();
    }
  }

  
  //glFlush();
  glFinish();
  //glutSwapBuffers(); /** for DoubleBuffer **/
  
  return ;
}  

