/**************************************/
/* $B%X%"%*%V%8%'%/%H9=B$BN(B             */
/**************************************/
struct HairObjData{
  struct PolyObjData *head ;
  struct HG_List     *hgl  ;
  char   fname[MAX_PATH] ;
} ;

struct OpStatus{
  int hideHGP   ;
  int hideHG    ;
  int hideHead  ;
  int hideHeadP ;
  int edit_mode ;
  int sync_mode ;
  int edit_gid  ;
  int fileloaded ;

} ;

struct POVparam{
  int     bezier_step ;
  int     density ;
  double  r,g,b,f,t ;
  double  diffuse ;
  double  specular ;
  double  radius_s ;
  double  radius_e ;
} ;

extern struct OpStatus     opstat ;
extern struct HairObjData  *HOBJ ;
extern struct View3D       view3d ;
extern struct POVparam     pov_param ;

extern int     startx ;
extern int     starty ;
extern int     keystat ;
extern int     mouse_Button ;
extern int     alt_stat ;
extern int     shift_stat ;
extern int     cntl_stat ;

extern char   *edit_mode_list[] ;
extern char   *sync_mode_list[] ;
extern char   *HG_disp_list[]   ;

extern char   *gid_num[] ;

extern char   *inputhair  ;
extern char   *input3ds   ;
extern char   *outputhair ;
extern char   *outputpov  ;

extern char   default_inputhair[] ;
extern char   default_input3ds[]  ;
extern char   default_outputhair[];
extern char   default_outputpov[] ;

extern GLfloat light0pos[] ;


extern GLfloat s_ctlpoints[48];
extern GLfloat s_knots[8] ;

extern GLUnurbsObj *theNurb;

struct HairObjData *read_3ds( char *fname ) ;
struct element_HG   search_HG( struct View3D *view3d, struct HG_List *HGL ) ;
int                 move_HG( struct View3D *view3d, struct HG_List *HGL, int mode ) ;
struct HG_List     *init_HG( int HGmax ) ;
struct element_HG   select_HG( struct View3D *view3d, struct HG_List *HGL, int mode ) ;
int                 selectall_HG( struct View3D *view3d, struct HG_List *HGL, int mode ) ;

int                 search_HR( struct View3D *view3d, struct PolyObjData *Poly) ;
int                 setdraw_HR( struct View3D *view3d, struct PolyObjData *Poly) ;
int                 select_HR( struct View3D *view3d, struct PolyObjData *Poly, int mode) ;
int                 selectall_HR( struct View3D *view3d, struct PolyObjData *Poly, int mode ) ;
int                 selectgid_HG( struct View3D *view3d, struct HG_List *HGL, int gid ) ;
int                 del_HG( struct HG_List *HGL ) ;
int                 gen_HG( struct PolyObjData *Poly, struct HG_List *HGL, int gid ) ;
int                 chg_HGgid( struct PolyObjData *Poly, struct HG_List *HGL, int gid ) ;
int                 write_hair(char *fname, struct HairObjData *hobj ) ;
struct HairObjData *read_hair( char *fname ) ;
int                 init_povparam( struct POVparam *param ) ;
int                 write_pov(char *fname, struct HairObjData *hobj, struct POVparam *param ) ;
int                 clr_his( struct SelHist *his ) ;
int                 add_HS( struct View3D *view3d ) ;
int                 clr_HS( struct View3D *view3d ) ;
int                 sys_init() ;
struct HairObjData *init_hairobj() ;
int                 free_hairobj(struct HairObjData *hobj) ;



#define MAX_HG_NUM 8000

#define READ_HAIR (0)
#define READ_3DS  (1)
