#include <stdlib.h>
#include <stdio.h>
#include <GL/glut.h>
#include <math.h>
#include "vector.h"
#include "obj.h"

int move_HG( struct View3D *view3d, struct HG_List *HGL, int mode )
{
  struct element_HG element=view3d->HGno ;
  struct Vec3D cur ;
  struct Vec3D sta ;
  struct Vec3D mov ;

  struct Vec3D x_axis ;
  struct Vec3D y_axis ;
  int    i ;

  if( element.n<0  ) return(0) ;
  if( element.p<=0 ) return(0) ; /*** $BLS:,$OF0$+$;$J$$(B ***/

  x_axis.x=1.0 ; x_axis.y=0.0 ; x_axis.z=0.0 ;
  y_axis.x=0.0 ; y_axis.y=1.0 ; y_axis.z=0.0 ;
  
  sta=view3d->sta ;
  cur=view3d->cur ;
  
  SubVec( &sta, &view3d->p, &sta ) ;
  SubVec( &cur, &view3d->p, &cur ) ;
  RotateVec( &sta, view3d->r.x, &x_axis ) ;
  RotateVec( &sta, view3d->r.y, &y_axis ) ;
  RotateVec( &cur, view3d->r.x, &x_axis ) ;
  RotateVec( &cur, view3d->r.y, &y_axis ) ;

  SubVec( &sta, &cur, &mov ) ;
  ScaleVec( &mov, view3d->scale, &mov ) ;

  if( element.n>=0 || element.n<HGL->n ){ /** $BCmL\%X%"%,%$%I$rJT=8$9$k(B **/
    i=element.n ;
    if( (element.p % 3)==0 ){
      if( (element.p-1)>=0 ){
	HGL->HG[i].plist[(element.p-1)*3+0] -= mov.x ;
	HGL->HG[i].plist[(element.p-1)*3+1] -= mov.y ;
	HGL->HG[i].plist[(element.p-1)*3+2] -= mov.z ;
      }
      if( (element.p+1)<HGL->HG[i].pnum ){
	HGL->HG[i].plist[(element.p+1)*3+0] -= mov.x ;
	HGL->HG[i].plist[(element.p+1)*3+1] -= mov.y ;
	HGL->HG[i].plist[(element.p+1)*3+2] -= mov.z ;
      }
    }else{
      if( (element.p % 3)==1 ){
	if( (element.p-2)>=0 ){
	  HGL->HG[i].plist[(element.p-2)*3+0] += mov.x ;
	  HGL->HG[i].plist[(element.p-2)*3+1] += mov.y ;
	  HGL->HG[i].plist[(element.p-2)*3+2] += mov.z ;
	}
      }else{
	if( (element.p+2)<HGL->HG[i].pnum ){
	  HGL->HG[i].plist[(element.p+2)*3+0] += mov.x ;
	  HGL->HG[i].plist[(element.p+2)*3+1] += mov.y ;
	  HGL->HG[i].plist[(element.p+2)*3+2] += mov.z ;
	}
      }
    }
    HGL->HG[i].plist[element.p*3+0] -= mov.x ;
    HGL->HG[i].plist[element.p*3+1] -= mov.y ;
    HGL->HG[i].plist[element.p*3+2] -= mov.z ;
  }

  if( mode==1 ){ /*** $BK!@~4p=`F14|JT=8%b!<%I(B ***/
    struct Vec3D vec_p  ;
    struct Vec3D vec_o  ;
    struct Vec3D vec_pxz  ;
    struct Vec3D vec_oxz  ;
    struct Vec3D shaft1  ;
    struct Vec3D shaft2  ;
    struct Vec3D p2pvec ;
    struct Vec3D tmp3d ;
    struct Vec3D axis_y ;
    double th1,th2,tmpth ;
    int    i,j ;

    axis_y.x=0.0 ; axis_y.y=1.0 ; axis_y.z=0.0 ;
    vec_o=HGL->HG[element.n].rn ;
    CrossProduct(&axis_y,&vec_o,&tmp3d) ;
    tmpth=DotProduct(&axis_y,&vec_o)/(LengthVec(&vec_o)) ;
    if( tmpth!=-1.0 && tmpth!=1.0 ){ /*** y$B<4$KJ?9T$G$J$1$l$P<B9T2DG=(B ***/
      vec_oxz  =vec_o ;
      vec_oxz.y=0.0 ; /*** XZ$BJ?LL$KEj1F$9$k(B ***/
      NormalizeVec(&vec_oxz, &vec_oxz) ;
      for( i=0 ; i<HGL->n ; i++ ){
	if( view3d->gp[HGL->HG[i].gid].hide!=0 ) continue ;
	if( i!=element.n && HGL->HG[i].sel==1 ){
	  vec_p=HGL->HG[i].rn ;
	  tmpth=DotProduct(&axis_y,&vec_p)/(LengthVec(&vec_p)) ;
	  if( tmpth==-1.0 || tmpth==1.0 ){ /***y$B<4$KJ?9T$J$i$P%9%-%C%W(B***/
	    continue ;
	  }
	  vec_pxz  =vec_p ;
	  vec_pxz.y=0.0 ; /*** XZ$BJ?LL$KEj1F$9$k(B ***/
	  NormalizeVec(&vec_pxz, &vec_pxz) ;

	  tmpth=DotProduct( &vec_oxz, &vec_pxz )/(LengthVec(&vec_oxz)*LengthVec(&vec_pxz)) ;
	  th1= acos(tmpth) ;
	  if( tmpth==-1.0 ){ /*** 180$BEY$N;~(B ***/
	    shaft1=axis_y ;
	  }else{
	    CrossProduct( &vec_pxz, &vec_oxz, &shaft1 ) ;
	    NormalizeVec(&shaft1,&shaft1) ;
	  }

	  tmp3d=vec_o ;
	  if( th1!= 0.0 ){
	    RotateVecRad( &tmp3d, th1, &shaft1 ) ;
	  }
	  
	  th2= acos(DotProduct( &tmp3d, &vec_p )/(LengthVec(&tmp3d)*LengthVec(&vec_p))) ;
	  CrossProduct( &vec_p, &tmp3d, &shaft2) ;
	  NormalizeVec(&shaft2,&shaft2) ;
	  
	  for( j=1 ; j<(HGL->HG[element.n].pnum/3) ; j++ ){
	    if( j<(HGL->HG[i].pnum/3) ){
	      p2pvec.x=HGL->HG[element.n].plist[j*3+0] ;
	      p2pvec.y=HGL->HG[element.n].plist[j*3+1] ;
	      p2pvec.z=HGL->HG[element.n].plist[j*3+2] ;
	      SubVec( &p2pvec , &HGL->HG[element.n].rp , &p2pvec ) ;
	      if( th1!=0.0 ){
		RotateVecRad( &p2pvec, th1, &shaft1 ) ;
	      }
	      if( th2!=0.0 ){
		RotateVecRad( &p2pvec, th2, &shaft2 ) ;
	      }
	      AddVec( &HGL->HG[i].rp, &p2pvec, &p2pvec ) ;
	      HGL->HG[i].plist[j*3+0]=p2pvec.x ;
	      HGL->HG[i].plist[j*3+1]=p2pvec.y ;
	      HGL->HG[i].plist[j*3+2]=p2pvec.z ;
	    }
	  }
	}
      }
    }
  }else{ /*** $BD>@~0\F0F14|JT=8%b!<%I(B ***/
    for( i=0 ; i<HGL->n ; i++ ){
      if( view3d->gp[HGL->HG[i].gid].hide!=0 ) continue ;
      if( i!=element.n && HGL->HG[i].sel==1 ){
	if( (element.p % 3)==0 ){
	  if( (element.p-1)>=0 ){
	    HGL->HG[i].plist[(element.p-1)*3+0] -= mov.x ;
	    HGL->HG[i].plist[(element.p-1)*3+1] -= mov.y ;
	    HGL->HG[i].plist[(element.p-1)*3+2] -= mov.z ;
	  }
	  if( (element.p+1)<HGL->HG[i].pnum ){
	    HGL->HG[i].plist[(element.p+1)*3+0] -= mov.x ;
	    HGL->HG[i].plist[(element.p+1)*3+1] -= mov.y ;
	    HGL->HG[i].plist[(element.p+1)*3+2] -= mov.z ;
	  }
	}else{
	  if( (element.p % 3)==1 ){
	    if( (element.p-2)>=0 ){
	      HGL->HG[i].plist[(element.p-2)*3+0] += mov.x ;
	      HGL->HG[i].plist[(element.p-2)*3+1] += mov.y ;
	      HGL->HG[i].plist[(element.p-2)*3+2] += mov.z ;
	    }
	  }else{
	    if( (element.p+2)<HGL->HG[i].pnum ){
	      HGL->HG[i].plist[(element.p+2)*3+0] += mov.x ;
	      HGL->HG[i].plist[(element.p+2)*3+1] += mov.y ;
	      HGL->HG[i].plist[(element.p+2)*3+2] += mov.z ;
	    }
	  }
	}
	HGL->HG[i].plist[element.p*3+0] -= mov.x ;
	HGL->HG[i].plist[element.p*3+1] -= mov.y ;
	HGL->HG[i].plist[element.p*3+2] -= mov.z ;
      }
    }
  }
  
  return(0) ;
}
  
