/********************************************************************************
  set draw HairRoot($BLS:,(B)
********************************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <GL/glut.h>
#include <math.h>
#include "vector.h"
#include "obj.h"

int setdraw_HR( struct View3D *view3d, struct PolyObjData *Poly)
{
  struct Vec3D cur ;
  struct Vec3D eye ;
  struct Vec3D ray ;
  struct Vec3D x_axis ;
  struct Vec3D y_axis ;
  int i ;
  
  x_axis.x=1.0 ; x_axis.y=0.0 ; x_axis.z=0.0 ;
  y_axis.x=0.0 ; y_axis.y=1.0 ; y_axis.z=0.0 ;

  eye=view3d->v ;
  cur=view3d->cur ;
  
  SubVec( &eye, &view3d->p, &eye ) ;
  SubVec( &cur, &view3d->p, &cur ) ;
  RotateVec( &eye, view3d->r.x, &x_axis ) ;
  RotateVec( &eye, view3d->r.y, &y_axis ) ;
  RotateVec( &cur, view3d->r.x, &x_axis ) ;
  RotateVec( &cur, view3d->r.y, &y_axis ) ;

  SubVec( &cur, &eye, &ray ) ;

  for( i=0 ; i<Poly->pnum ; i++ ){
    Poly->draw[i]=0 ;
  }
  for( i=0 ; i<Poly->fnum ; i++ ){
    double res ;
    res = DotProduct(&Poly->flist[i].normal,&ray) ;
    if( res<=0.0 ){
      Poly->draw[Poly->flist[i].p0]=1 ;
      Poly->draw[Poly->flist[i].p1]=1 ;
      Poly->draw[Poly->flist[i].p2]=1 ;
    }
  }

  return(0) ;
}
  
