#include <windows.h>
#include <windowsx.h>
#include <stdlib.h>
#include <stdio.h>
#include "gluw.h"
#include "vector.h"
#include "obj.h"
#include "hair.h"
#include "resource.h"

extern HINSTANCE hInst;

int win_FileOpen(HWND);
int win_3dsOpen(HWND) ;
int win_FileSaveAs(HWND) ;
int win_FilePovex(HWND) ;
BOOL CALLBACK VerDialogProc(HWND hWnd , UINT msg , WPARAM wp , LPARAM lp) ;
BOOL CALLBACK POVExportDialogProc(HWND hWnd , UINT msg , WPARAM wp , LPARAM lp) ;

int win_command(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
  switch (LOWORD(wp)) {
    /***** File menu *****/
  case IDM_OPEN:
    win_FileOpen(hWnd) ;
    opstat.fileloaded=1 ;
    break ;
  case IDM_IMPORT:
    win_3dsOpen(hWnd) ;
    opstat.fileloaded=1 ;
    break ;
  case IDM_EXPORT:
    DialogBox((HINSTANCE)GetWindowLong(hWnd , GWL_HINSTANCE) ,
              TEXT("POVDLG") , hWnd , POVExportDialogProc
              );
    win_FilePovex(hWnd) ;
    break ;
  case IDM_SAVE:
    //write_hair(HOBJ->fname,HOBJ) ;
    break ;
  case IDM_SAVEAS:
    win_FileSaveAs(hWnd) ;
    break ;
  case IDM_EXIT:
    SendMessage(hWnd, WM_CLOSE, 0, 0);
    break;

    /***** Edit menu *****/
  case IDM_EDITGUIDE:
  case IDM_SELECTROOT:
    gluw_keyboard((int)('m'), 0,0) ;
    break ;
  case IDM_SYNCLINER:
  case IDM_SYNCNORMAL:
    gluw_keyboard((int)('n'), 0,0) ;
    break ;
  case IDM_GROUP0:
    gluw_keyboard((int)('1'), 0,0) ;
    RedrawWindow( hWnd, NULL, NULL, RDW_INVALIDATE) ;
    break ;
  case IDM_GROUP1:
    gluw_keyboard((int)('2'), 0,0) ;
    RedrawWindow( hWnd, NULL, NULL, RDW_INVALIDATE) ;
    break ;
  case IDM_GROUP2:
    gluw_keyboard((int)('3'), 0,0) ;
    RedrawWindow( hWnd, NULL, NULL, RDW_INVALIDATE) ;
    break ;
  case IDM_GROUP3:
    gluw_keyboard((int)('4'), 0,0) ;
    RedrawWindow( hWnd, NULL, NULL, RDW_INVALIDATE) ;
    break ;
  case IDM_GENHG:
    gluw_keyboard((int)('g'), 0,0) ;
    RedrawWindow( hWnd, NULL, NULL, RDW_INVALIDATE) ;
    break ;
  case IDM_DELHG:
    gluw_keyboard((int)(VK_DELETE), 0,0) ;
    RedrawWindow( hWnd, NULL, NULL, RDW_INVALIDATE) ;
    break ;
  case IDM_CHGGRP:
    gluw_keyboard((int)('c'), 0,0) ;
    RedrawWindow( hWnd, NULL, NULL, RDW_INVALIDATE) ;
    break ;
  case IDM_GENSFACE:
    gluw_keyboard((int)('y'), 0,0) ;
    RedrawWindow( hWnd, NULL, NULL, RDW_INVALIDATE) ;
    break ;
  case IDM_DELSFACE:
    gluw_keyboard((int)('x'), 0,0) ;
    RedrawWindow( hWnd, NULL, NULL, RDW_INVALIDATE) ;
    break ;
    
    /***** View menu *****/
  case IDM_VIEWRESET:
    gluw_keyboard((int)('r'), 0,0) ;
    RedrawWindow( hWnd, NULL, NULL, RDW_INVALIDATE) ;
    break ;
  case IDM_VIEWSHOWHG:
  case IDM_VIEWHIDEHG:
    gluw_keyboard((int)('S'), 0,0) ;
    RedrawWindow( hWnd, NULL, NULL, RDW_INVALIDATE) ;
    break ;
  case IDM_VIEWSHOWCP:
  case IDM_VIEWHIDECP:
    gluw_keyboard((int)('s'), 0,0) ;
    RedrawWindow( hWnd, NULL, NULL, RDW_INVALIDATE) ;
    break ;
  case IDM_VIEWSHOWHR:
  case IDM_VIEWHIDEHR:
    gluw_keyboard((int)('H'), 0,0) ;
    RedrawWindow( hWnd, NULL, NULL, RDW_INVALIDATE) ;
    break ;
  case IDM_VIEWSHOWOBJ:
  case IDM_VIEWHIDEOBJ:
    gluw_keyboard((int)('h'), 0,0) ;
    RedrawWindow( hWnd, NULL, NULL, RDW_INVALIDATE) ;
    break ;
  case IDM_VIEWSHOWGP0:
  case IDM_VIEWHIDEGP0:
    gluw_keyboard((int)('!'), 0,0) ;
    RedrawWindow( hWnd, NULL, NULL, RDW_INVALIDATE) ;
    break ;
  case IDM_VIEWSHOWGP1:
  case IDM_VIEWHIDEGP1:
    gluw_keyboard((int)('\"'), 0,0) ;
    RedrawWindow( hWnd, NULL, NULL, RDW_INVALIDATE) ;
    break ;
  case IDM_VIEWSHOWGP2:
  case IDM_VIEWHIDEGP2:
    gluw_keyboard((int)('#'), 0,0) ;
    RedrawWindow( hWnd, NULL, NULL, RDW_INVALIDATE) ;
    break ;
  case IDM_VIEWSHOWGP3:
  case IDM_VIEWHIDEGP3:
    gluw_keyboard((int)('$'), 0,0) ;
    RedrawWindow( hWnd, NULL, NULL, RDW_INVALIDATE) ;
    break ;

    /***** Select menu *****/
  case IDM_SELALL:
    gluw_keyboard((int)('a'), 0,0) ;
    RedrawWindow( hWnd, NULL, NULL, RDW_INVALIDATE) ;
    break ;
  case IDM_UNSELALL:
    gluw_keyboard((int)(' '), 0,0) ;
    RedrawWindow( hWnd, NULL, NULL, RDW_INVALIDATE) ;
    break ;
		  
    /***** Help menu *****/
  case IDM_VERSION:
    DialogBox((HINSTANCE)GetWindowLong(hWnd , GWL_HINSTANCE) ,
              TEXT("VERDLG") , hWnd , VerDialogProc
              );
    return(0) ;
    break ;
  }
  return(0) ;
}


BOOL CALLBACK VerDialogProc(HWND hWnd , UINT msg , WPARAM wp , LPARAM lp)
{
  switch (msg) {
  case WM_CLOSE:
    EndDialog(hWnd , IDOK);
    return(TRUE);
  case WM_COMMAND:
    switch (LOWORD(wp)) {
    case IDOK:
      EndDialog(hWnd, IDOK);
      return(TRUE);
    }
  }
  return(FALSE) ;
}


#define STRLEN   (64)
BOOL CALLBACK POVExportDialogProc(HWND hWnd , UINT msg , WPARAM wp , LPARAM lp)
{
  static HWND Edit_Step    ;
  static HWND Edit_Density ;
  static HWND Edit_r       ;
  static HWND Edit_g       ;
  static HWND Edit_b       ;
  static HWND Edit_f       ;
  static HWND Edit_t       ;
  static HWND Edit_diff    ;
  static HWND Edit_spec    ;
  static HWND Edit_rs      ;
  static HWND Edit_re      ;

  char strtmp[STRLEN] ;
  
  switch (msg) {

  case WM_INITDIALOG:
    Edit_Step    =GetDlgItem(hWnd,IDC_POV_BZSTEP   ) ;
    Edit_Density =GetDlgItem(hWnd,IDC_POV_DENSITY  ) ;
    Edit_r       =GetDlgItem(hWnd,IDC_POV_RED      ) ;
    Edit_g       =GetDlgItem(hWnd,IDC_POV_GREEN    ) ;
    Edit_b       =GetDlgItem(hWnd,IDC_POV_BLUE     ) ;
    Edit_f       =GetDlgItem(hWnd,IDC_POV_FILTER   ) ;
    Edit_t       =GetDlgItem(hWnd,IDC_POV_TRANSMIT ) ;
    Edit_diff    =GetDlgItem(hWnd,IDC_POV_DIFFUSE  ) ;
    Edit_spec    =GetDlgItem(hWnd,IDC_POV_SPECULAR ) ;
    Edit_rs      =GetDlgItem(hWnd,IDC_RAD_S        ) ;
    Edit_re      =GetDlgItem(hWnd,IDC_RAD_E        ) ;

    sprintf(strtmp,"%d",pov_param.bezier_step) ;  Edit_SetText(Edit_Step    ,strtmp) ;
    sprintf(strtmp,"%d",pov_param.density    ) ;  Edit_SetText(Edit_Density ,strtmp) ;
    sprintf(strtmp,"%f",pov_param.r          ) ;  Edit_SetText(Edit_r       ,strtmp) ;
    sprintf(strtmp,"%f",pov_param.g          ) ;  Edit_SetText(Edit_g       ,strtmp) ;
    sprintf(strtmp,"%f",pov_param.b          ) ;  Edit_SetText(Edit_b       ,strtmp) ;
    sprintf(strtmp,"%f",pov_param.f          ) ;  Edit_SetText(Edit_f       ,strtmp) ;
    sprintf(strtmp,"%f",pov_param.t          ) ;  Edit_SetText(Edit_t       ,strtmp) ;
    sprintf(strtmp,"%f",pov_param.diffuse    ) ;  Edit_SetText(Edit_diff    ,strtmp) ;
    sprintf(strtmp,"%f",pov_param.specular   ) ;  Edit_SetText(Edit_spec    ,strtmp) ;
    sprintf(strtmp,"%f",pov_param.radius_s   ) ;  Edit_SetText(Edit_rs      ,strtmp) ;
    sprintf(strtmp,"%f",pov_param.radius_e   ) ;  Edit_SetText(Edit_re      ,strtmp) ;
    return(TRUE);
    
  case WM_CLOSE:
    EndDialog(hWnd , IDOK);
    return(TRUE);
    //  case WM_PAINT:
    //    {
    //      PAINTSTRUCT ps;
    //      HDC hdc;
    //      
    //      hdc = BeginPaint(hWnd, &ps);
    //      TextOut(hdc,0,0,(LPCTSTR)"aaaaa",5) ;
    //      EndPaint(hWnd, &ps);
    //    }
    //    return(TRUE) ;
  case WM_COMMAND:
    switch (LOWORD(wp)) {
    case IDOK:
      {
      	int    i ;
	double f ;
      	Edit_GetText(Edit_Step   , strtmp, 32) ; i=atoi(strtmp) ;
      	pov_param.bezier_step = i<1 ? 1 : (i>64 ? 64 : i) ;
      	Edit_GetText(Edit_Density, strtmp, 32) ; i=atoi(strtmp) ;
      	pov_param.density     = i<0 ? 0 : (i>65535 ? 65535 : i) ;
      	Edit_GetText(Edit_r      , strtmp, 32) ; f=atof(strtmp) ;
      	pov_param.r           = f<0.0 ? 0.0 : (f>1.0 ? 1.0 : f) ;
      	Edit_GetText(Edit_g      , strtmp, 32) ; f=atof(strtmp) ;
      	pov_param.g           = f<0.0 ? 0.0 : (f>1.0 ? 1.0 : f) ;
      	Edit_GetText(Edit_b      , strtmp, 32) ; f=atof(strtmp) ;
      	pov_param.b           = f<0.0 ? 0.0 : (f>1.0 ? 1.0 : f) ;
      	Edit_GetText(Edit_f      , strtmp, 32) ; f=atof(strtmp) ;
      	pov_param.f           = f<0.0 ? 0.0 : (f>1.0 ? 1.0 : f) ;
      	Edit_GetText(Edit_t      , strtmp, 32) ; f=atof(strtmp) ;
      	pov_param.t           = f<0.0 ? 0.0 : (f>1.0 ? 1.0 : f) ;
      	Edit_GetText(Edit_diff   , strtmp, 32) ; f=atof(strtmp) ;
      	pov_param.diffuse     = f<0.0 ? 0.0 : (f>1.0 ? 1.0 : f) ;
      	Edit_GetText(Edit_spec   , strtmp, 32) ; f=atof(strtmp) ;
      	pov_param.specular    = f<0.0 ? 0.0 : (f>1.0 ? 1.0 : f) ;
      	Edit_GetText(Edit_rs     , strtmp, 32) ; f=atof(strtmp) ;
      	pov_param.radius_s    = f<0.0 ? 0.0 : (f>1.0 ? 1.0 : f) ;
      	Edit_GetText(Edit_re     , strtmp, 32) ; f=atof(strtmp) ;
      	pov_param.radius_e    = f<0.0 ? 0.0 : (f>1.0 ? 1.0 : f) ;
      }
      EndDialog(hWnd, IDOK);
      return(TRUE);
    case IDC_POV_BZSTEP   :
      return(TRUE);
    case IDC_POV_DENSITY  :
      return(TRUE);
    case IDC_POV_RED      :
      return(TRUE);
    case IDC_POV_GREEN    :
      return(TRUE);
    case IDC_POV_BLUE     :
      return(TRUE);
    case IDC_POV_FILTER   :
      return(TRUE);
    case IDC_POV_TRANSMIT :
      return(TRUE);
    case IDC_POV_DIFFUSE  :
      return(TRUE);
    case IDC_POV_SPECULAR :
      return(TRUE);
    case IDC_RAD_S        :
      return(TRUE);
    case IDC_RAD_E        :
      return(TRUE);
    }
  }
  return(FALSE) ;
}




