#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "gluw.h"
#include "vector.h"
#include "obj.h"
#include "hair.h"

#define BEZIER_STEP  (8)
#define DENSITY      (5000)
#define RADIUSs      (0.0009)
#define RADIUSe      (0.0007)

int output_macro( FILE *fp, struct POVparam *param ) ;
int output_hair_param( FILE *fp, struct POVparam *param ) ;
int output_obj_header( FILE *fp, struct POVparam *param ) ;
int output_object( FILE *fp, int pnum , GLfloat *points, struct POVparam *param ) ;
int output_obj_footer( FILE *fp, struct POVparam *param ) ;

int plot_Bezier(int pnum, GLfloat *plist, GLfloat *points, int step ) ;

int write_pov( char *fname, struct HairObjData *hobj, struct POVparam *param )
{
  FILE   *fp ;
  int    i,j,k,g ;
  struct Vec3D e0 ;
  struct Vec3D e1 ;
  struct Vec3D pc ;
  struct Vec3D tmpvec1 ;
  struct Vec3D tmpvec2 ;
  double Sa,S0,S1,S2 ;
  int    hr0,hr1,hr2 ;
  int    haircount ;
  struct HairGuide HG0, HG1, HG2, HG ;
  int    totalhair ;
  struct HG_List *HGL ;
  struct PolyObjData *obj ;
  //GLfloat points[1000] ;
  
  if( hobj==NULL ) return(0) ;
  HGL=hobj->hgl ;
  obj=hobj->head ;
  
  fp=fopen(fname,"wb") ;
  if( fp==NULL ) return(-1) ;

  output_hair_param(fp,param) ;
  output_macro(fp,param) ;
  output_obj_header(fp,param) ;

  totalhair=0 ;
  for( g=0 ; g<GPNUM ; g++ ){
    for( i=0 ; i<obj->pnum ; i++ ) obj->HGid[i]=-1 ;
    for( i=0 ; i<HGL->n ; i++ ){
      if( HGL->HG[i].gid==g ){
	obj->HGid[HGL->HG[i].pid]=i ;
      }
    }
    
    for( i=0 ; i<obj->fnum ; i++ ){
      hr0=obj->HGid[obj->flist[i].p0] ;
      hr1=obj->HGid[obj->flist[i].p1] ;
      hr2=obj->HGid[obj->flist[i].p2] ;
      if( hr0!=-1 ) HG0=HGL->HG[hr0] ;
      if( hr1!=-1 ) HG1=HGL->HG[hr1] ;
      if( hr2!=-1 ) HG2=HGL->HG[hr2] ;
      
      if( hr0>=0 && hr1>=0 && hr2>=0 ){ /** |S̎O_ɃKCh݂ **/
	SubVec( &obj->plist[obj->flist[i].p0],
		&obj->plist[obj->flist[i].p1],
		&e0 ) ;
	SubVec( &obj->plist[obj->flist[i].p0],
		&obj->plist[obj->flist[i].p2],
		&e1 ) ;
	CrossProduct( &e0, &e1, &tmpvec1 ) ;
	Sa=LengthVec(&tmpvec1)/2.0 ; /** |S̖ʐ **/
	haircount=(int)(Sa*param->density) ;
	totalhair+=haircount ;
	printf("face=%5d  : %5d\n",i,haircount) ;
	for( k=0 ; k<haircount ; k++ ){
	  ScaleVec( &e0, (double)(rand()%1000)/1000.0, &tmpvec1 ) ;
	  SubVec( &e1, &tmpvec1,  &tmpvec2 ) ;
	  ScaleVec( &tmpvec2, (double)(rand()%1000)/1000.0, &tmpvec2 ) ;
	  AddVec( &tmpvec1, &tmpvec2, &pc ) ;
	  
	  CrossProduct( &pc, &e0, &tmpvec2 ) ;
	  S2=LengthVec(&tmpvec2)/2.0 ; /** P0,P1,Pc̖ʐ **/
	  CrossProduct( &pc, &e1, &tmpvec2 ) ;
	  S1=LengthVec(&tmpvec2)/2.0 ; /** P0,P2,Pc̖ʐ **/
	  S0=Sa-S1-S2 ;                /** P1,P2,Pc̖ʐ **/
	  
	  //printf("%f %f %f %f\n",S0,S1,S2,Sa) ;
	  HG=HG0 ;
	  for( j=0 ; j<HG.pnum ; j++ ){
	    HG.plist[j]=HG0.plist[j]*S0/Sa + HG1.plist[j]*S1/Sa + HG2.plist[j]*S2/Sa ;
	  }
	  
	  //plot_Bezier( HG.pnum, HG.plist, points, BEZIER_STEP ) ;
	  output_object( fp, HG.pnum, HG.plist,param ) ;
	}
	continue ;
      }
      if( (hr0>=0  && hr1>=0  && hr2==-1 ) ){
	SubVec( &obj->plist[obj->flist[i].p0],
		&obj->plist[obj->flist[i].p1],
		&e0 ) ;
	Sa=LengthVec(&e0) ; /** ӂ̒ **/
	haircount=(int)(Sa*sqrt(param->density)*1.5) ;
	totalhair+=haircount ;
	printf("face=%5d  : %5d\n",i,haircount) ;
	for( k=0 ; k<haircount ; k++ ){
	  ScaleVec( &e0, (double)(rand()%1000)/1000.0, &tmpvec1 ) ;
	  S1=LengthVec(&tmpvec1) ;
	  S0=Sa-S1 ;
	  HG=HG0 ;
	  for( j=0 ; j<HG.pnum ; j++ ){
	    HG.plist[j]=HG0.plist[j]*S0/Sa + HG1.plist[j]*S1/Sa ;
	  }
	  
	  //plot_Bezier( HG.pnum, HG.plist, points, BEZIER_STEP ) ;
	  output_object( fp, HG.pnum, HG.plist, param ) ;
	}
	continue ;
      }
      if( (hr0>=0  && hr1==-1 && hr2>=0  ) ){
	SubVec( &obj->plist[obj->flist[i].p0],
		&obj->plist[obj->flist[i].p2],
		&e0 ) ;
	Sa=LengthVec(&e0) ; /** ӂ̒ **/
	haircount=(int)(Sa*sqrt(param->density)*1.5) ;
	totalhair+=haircount ;
	printf("face=%5d  : %5d\n",i,haircount) ;
	for( k=0 ; k<haircount ; k++ ){
	  ScaleVec( &e0, (double)(rand()%1000)/1000.0, &tmpvec1 ) ;
	  S2=LengthVec(&tmpvec1) ;
	  S0=Sa-S2 ;
	  HG=HG0 ;
	  for( j=0 ; j<HG.pnum ; j++ ){
	    HG.plist[j]=HG0.plist[j]*S0/Sa + HG2.plist[j]*S2/Sa ;
	  }
	  
	  //plot_Bezier( HG.pnum, HG.plist, points, BEZIER_STEP ) ;
	  output_object( fp, HG.pnum, HG.plist, param ) ;
	}
	continue ;
      }
      if( (hr0==-1 && hr1>=0  && hr2>=0  ) ){
	SubVec( &obj->plist[obj->flist[i].p1],
		&obj->plist[obj->flist[i].p2],
		&e0 ) ;
	Sa=LengthVec(&e0) ; /** ӂ̒ **/
	haircount=(int)(Sa*sqrt(param->density)*1.5) ;
	totalhair+=haircount ;
	printf("face=%5d  : %5d\n",i,haircount) ;
	for( k=0 ; k<haircount ; k++ ){
	  ScaleVec( &e0, (double)(rand()%1000)/1000.0, &tmpvec1 ) ;
	  S2=LengthVec(&tmpvec1) ;
	  S1=Sa-S2 ;
	  HG=HG0 ;
	  for( j=0 ; j<HG.pnum ; j++ ){
	    HG.plist[j]=HG1.plist[j]*S1/Sa + HG2.plist[j]*S2/Sa ;
	  }
	  
	  //plot_Bezier( HG.pnum, HG.plist, points, BEZIER_STEP ) ;
	  output_object( fp, HG.pnum, HG.plist, param ) ;
	}
	continue ;
      }
    }
  }
      
  for( i=0 ; i<HGL->n ; i++ ){
    //plot_Bezier(HGL->HG[i].pnum, HGL->HG[i].plist, points, BEZIER_STEP ) ;
    output_object( fp, HGL->HG[i].pnum, HGL->HG[i].plist, param ) ;
    totalhair++ ;
  }
  
  output_obj_footer(fp,param) ;

  fclose(fp) ;
  printf("total = %d\n",totalhair) ;
  
  return(0) ;
}


/**********************************************************************/
int init_povparam( struct POVparam *param )
{
  if( param!=NULL ){
    param->bezier_step=BEZIER_STEP ;
    param->density    =DENSITY ;
    param->r          =0.50000 ;
    param->g          =0.20000 ;
    param->b          =0.00000 ;
    param->f          =0.00000 ;
    param->t          =0.00000 ;
    param->diffuse    =0.60000 ;
    param->specular   =0.80000 ;
    param->radius_s   =RADIUSs ;
    param->radius_e   =RADIUSe ;
    return(0) ;
  }
  return(-1) ;
}


/**********************************************************************/
int output_hair_param( FILE *fp, struct POVparam *param )
{
  fprintf(fp,"#declare HM_RS=%f;\n",param->radius_s) ;
  fprintf(fp,"#declare HM_RE=%f;\n",param->radius_e) ;
  fprintf(fp,"#declare HM_color =\n") ;
  fprintf(fp,"texture{\n") ;
  fprintf(fp,"  pigment{ rgbft <%f, %f, %f, %f, %f>}\n",
	  param->r,param->g,param->b,param->f,param->t) ;
  fprintf(fp,"  finish{\n") ;
  fprintf(fp,"    //ambient rgb <1.00000, 1.00000, 1.00000>\n") ;
  fprintf(fp,"    diffuse %f\n",param->diffuse) ;
  fprintf(fp,"    brilliance 1.00000\n") ;
  fprintf(fp,"    specular %f roughness 0.0040000\n",param->specular) ;
  fprintf(fp,"  }\n") ;
  fprintf(fp,"}\n") ;
  fprintf(fp,"\n") ;
  return(0) ;
}
  

/**********************************************************************/
int output_macro( FILE *fp, struct POVparam *param )
{
  fprintf(fp,"#macro BezierCurve1(Origin, Ctrl1, Ctrl2, End, RadiusS, RadiusE)\n") ;
  fprintf(fp,"  #local Step = 1/%d;\n",param->bezier_step) ;
  fprintf(fp,"  #local Rdiff= RadiusS - RadiusE;\n") ;
  fprintf(fp,"  union{\n") ;
  fprintf(fp,"    #local Pp = Origin;\n") ;
  fprintf(fp,"    #local T=Step;\n") ;
  fprintf(fp,"    #local TotalLength=0;\n") ;
  fprintf(fp,"    #while (T <= 1+Step/2)\n") ;
  fprintf(fp,"      #local U = 1-T;\n") ;
  fprintf(fp,"      #local P = U*U*U*Origin + 3*U*U*T*Ctrl1 + 3*U*T*T*Ctrl2 + T*T*T*End;\n") ;
  fprintf(fp,"      #local PpP= P-Pp;\n") ;
  fprintf(fp,"      #local TotalLength=TotalLength+vlength(PpP);\n") ;
  fprintf(fp,"      #local Pp = P;\n") ;
  fprintf(fp,"      #local T = T+Step;\n") ;
  fprintf(fp,"    #end\n") ;
  fprintf(fp,"\n") ;
  fprintf(fp,"    #local Pp = Origin;\n") ;
  fprintf(fp,"    #local T=Step;\n") ;
  fprintf(fp,"    #local Lp=0;\n") ;
  fprintf(fp,"    #while (T <= 1+Step/2)\n") ;
  fprintf(fp,"      #local U = 1-T;\n") ;
  fprintf(fp,"      #local P = U*U*U*Origin + 3*U*U*T*Ctrl1 + 3*U*T*T*Ctrl2 + T*T*T*End;\n") ;
  fprintf(fp,"      #local Ro= RadiusS - (Rdiff/TotalLength*Lp);\n") ;
  fprintf(fp,"      #local PpP= P-Pp;\n") ;
  fprintf(fp,"      #local Lp= Lp + vlength(PpP);\n") ;
  fprintf(fp,"      #local Re= RadiusS - (Rdiff/TotalLength*Lp);\n") ;
  fprintf(fp,"      cone{Pp, Ro, P, Re}\n") ;
  fprintf(fp,"      #local Pp = P;\n") ;
  fprintf(fp,"      #local T = T+Step;\n") ;
  fprintf(fp,"    #end\n") ;
  fprintf(fp,"  }\n") ;
  fprintf(fp,"#end\n") ;
  fprintf(fp,"\n") ;

  fprintf(fp,"#macro BezierCurve2(Origin, Ctrl1, Ctrl2, Center, Ctrl3, Ctrl4, End, RadiusS, RadiusE)\n") ;
  fprintf(fp,"  #local Step = 1/%d;\n",param->bezier_step) ;
  fprintf(fp,"  #local Rdiff= RadiusS - RadiusE;\n") ;
  fprintf(fp,"  union{\n") ;
  fprintf(fp,"    #local Pp = Origin;\n") ;
  fprintf(fp,"    #local T=Step;\n") ;
  fprintf(fp,"    #local TotalLength=0;\n") ;
  fprintf(fp,"    #while (T <= 1+Step/2)\n") ;
  fprintf(fp,"      #local U = 1-T;\n") ;
  fprintf(fp,"      #local P = U*U*U*Origin + 3*U*U*T*Ctrl1 + 3*U*T*T*Ctrl2 + T*T*T*Center;\n") ;
  fprintf(fp,"      #local PpP= P-Pp;\n") ;
  fprintf(fp,"      #local TotalLength=TotalLength+vlength(PpP);\n") ;
  fprintf(fp,"      #local Pp = P;\n") ;
  fprintf(fp,"      #local T = T+Step;\n") ;
  fprintf(fp,"    #end\n") ;
  fprintf(fp,"    #local Pp = Center;\n") ;
  fprintf(fp,"    #local T=Step;\n") ;
  fprintf(fp,"    #while (T <= 1+Step/2)\n") ;
  fprintf(fp,"      #local U = 1-T;\n") ;
  fprintf(fp,"      #local P = U*U*U*Center + 3*U*U*T*Ctrl3 + 3*U*T*T*Ctrl4 + T*T*T*End;\n") ;
  fprintf(fp,"      #local PpP= P-Pp;\n") ;
  fprintf(fp,"      #local TotalLength=TotalLength+vlength(PpP);\n") ;
  fprintf(fp,"      #local Pp = P;\n") ;
  fprintf(fp,"      #local T = T+Step;\n") ;
  fprintf(fp,"    #end\n") ;
  fprintf(fp,"\n") ;
  fprintf(fp,"    #local Pp = Origin;\n") ;
  fprintf(fp,"    #local T=Step;\n") ;
  fprintf(fp,"    #local Lp=0;\n") ;
  fprintf(fp,"    #while (T <= 1+Step/2)\n") ;
  fprintf(fp,"      #local U = 1-T;\n") ;
  fprintf(fp,"      #local P = U*U*U*Origin + 3*U*U*T*Ctrl1 + 3*U*T*T*Ctrl2 + T*T*T*Center;\n") ;
  fprintf(fp,"      #local Ro= RadiusS - (Rdiff/TotalLength*Lp);\n") ;
  fprintf(fp,"      #local PpP= P-Pp;\n") ;
  fprintf(fp,"      #local Lp= Lp + vlength(PpP);\n") ;
  fprintf(fp,"      #local Re= RadiusS - (Rdiff/TotalLength*Lp);\n") ;
  fprintf(fp,"      cone{Pp, Ro, P, Re}\n") ;
  fprintf(fp,"      #local Pp = P;\n") ;
  fprintf(fp,"      #local T = T+Step;\n") ;
  fprintf(fp,"    #end\n") ;
  fprintf(fp,"    #local Pp = Center;\n") ;
  fprintf(fp,"    #local T=Step;\n") ;
  fprintf(fp,"    #while (T <= 1+Step/2)\n") ;
  fprintf(fp,"      #local U = 1-T;\n") ;
  fprintf(fp,"      #local P = U*U*U*Center + 3*U*U*T*Ctrl3 + 3*U*T*T*Ctrl4 + T*T*T*End;\n") ;
  fprintf(fp,"      #local Ro= RadiusS - (Rdiff/TotalLength*Lp);\n") ;
  fprintf(fp,"      #local PpP= P-Pp;\n") ;
  fprintf(fp,"      #local Lp= Lp + vlength(PpP);\n") ;
  fprintf(fp,"      #local Re= RadiusS - (Rdiff/TotalLength*Lp);\n") ;
  fprintf(fp,"      cone{Pp, Ro, P, Re}\n") ;
  fprintf(fp,"      #local Pp = P;\n") ;
  fprintf(fp,"      #local T = T+Step;\n") ;
  fprintf(fp,"    #end\n") ;
  fprintf(fp,"  }\n") ;
  fprintf(fp,"#end\n") ;
  fprintf(fp,"\n") ;
  return(0) ;
}


/**********************************************************************/
int output_obj_header( FILE *fp, struct POVparam *param )
{
  fprintf(fp,"object{\n") ;
  fprintf(fp,"   union{\n") ;

  return(0) ;
}


/**********************************************************************/
int output_object( FILE *fp, int pnum , GLfloat *points, struct POVparam *param )
{
  int num ;
  int i ;

  if( pnum <= 4 ) return(-1) ;

  num=((pnum/3)-1)/3 ;

  if( num==1 ){
    fprintf(fp,"       BezierCurve1( ") ;
  }else{
    fprintf(fp,"       BezierCurve2( ") ;
  }
  for( i=0 ; i<pnum/3 ; i++ ){
    fprintf(fp,"<%f,%f,%f>,", points[(i*3)+0],points[(i*3)+1],points[(i*3)+2]) ;
  }
  fprintf(fp,"HM_RS,HM_RE") ;
  fprintf(fp,")\n") ;
  
  return(0) ;
}


/**********************************************************************/
int output_obj_footer( FILE *fp, struct POVparam *param )
{
  fprintf(fp,"   }\n") ;
  fprintf(fp,"   texture{\n") ;
  fprintf(fp,"     HM_color\n") ;
  fprintf(fp,"   }\n") ;
  fprintf(fp,"}\n") ;
  return(0) ;
}
